
#ifndef __DIALUPMANAGER_IMPL_H__
#define __DIALUPMANAGER_IMPL_H__
#include"isdnsystem.h"
#include"device_impl.h"
#include"prozess.h"

// Implementation for interface DialDevice
class DialDevice_impl : 
  virtual public Device_impl,
  virtual public POA_DialupManager::DialDevice
{
  protected:
    CosEventComm::PushSupplier_var psupplier;
    CosEventChannelAdmin::EventChannel_var eventchannel;
    CosEventChannelAdmin::ProxyPushConsumer_var eventconsumer;

    IsdnSystem *is;
    Process pinger;
    // Zustand
    DialupManager::DialDevice::Status altstatus;
    DialupManager::DialDevice::DialMode altdialmode;

  public:
    DialDevice_impl(const char *name,const char *desc,IsdnSystem *isdnsys);

    void dial()
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;

    void hangup()
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;

    void setdialmode( DialupManager::DialDevice::DialMode d )
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;

    DialupManager::DialDevice::DialMode getdialmode()
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;
    
    DialupManager::DialDevice::Status getstatus()
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;

    void activate()
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;

    void deactivate()
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;

    char* get_our_ip()
      throw(
        ::CORBA::SystemException,
        ::DialupManager::Syserr)
    ;

    char* get_peer_ip()
      throw(
        ::CORBA::SystemException,
        ::DialupManager::Syserr)
    ;

    CORBA::Long activechannels()
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;
    
    CosEventChannelAdmin::EventChannel_ptr geteventchannel()
	throw(
	    ::CORBA::SystemException,
	    DialupManager::Syserr)
	;

    /*-------- Ich bin ein pushsupplier ---------------*/
    void disconnect_push_supplier()
      throw(
        ::CORBA::SystemException)
    ;
    /*-------- Nichtschnittstellenfunktionen ----------*/
    void initpushsupplier(CosEventComm::PushSupplier_ptr psup,
			  CosEventChannelAdmin::EventChannel_ptr ech);
    
    void store(const char *datei);
    void cleanup();
    void aktionifchanged();
    void stop_pinger();
};

#endif





