/****************************************************************************
 * Header...: ifnameit.h                                                    *
 * Zweck....: Iterator zum auflisten der Netzwerkinterfaces                 *
 *            liest aus /proc/net/dev (LINUX)                               *
 * Autor....: Rudolf Weber Informatik- und Netzwerkverein Ravensburg e.V    *
 * Copyright: Nach GNU                                                      *
 ****************************************************************************/
#ifndef IFNAMEIT_H
#define IFNAMEIT_H
#include<iostream.h>
#include<fstream.h>
#include<string.h>
#define __USE_GNU
#include<ctype.h>

#define PROCDEV "/proc/net/dev"
class Ifnamit
{
    ifstream proc;
    char puffer[128];
public:
    Ifnamit():proc(PROCDEV,ios::in)
	{
	    next();
	}
    ~Ifnamit() {}
    const char *operator()()
	{
	    char *r=puffer;
	    while(*r!='\0' && (*r==' ' || *r=='\t')) r++;

	    return (*r!='\0' ? r : (char *)NULL);
	}
    const char *next()
	{
	    char *p;
	    if(proc.good() && !proc.eof())
	    {
		proc.getline(puffer,128);
	    }
	    else
	    {
		puffer[0]='\0';
		return (char *)NULL;
	    }
	    while(proc.good() && !proc.eof() && (p=index(puffer,':'))==NULL)
	    {
		proc.getline(puffer,128);p=NULL; 
	    }
	    if(proc.good() && !proc.eof() && p!=NULL) 
	    {
		*p='\0'; // Schneide Daten ab
		return puffer;
	    }
	    else
	    {
		puffer[0]='\0';
		return (char *)NULL;
	    }
	}
};
#endif
