//#include<CORBA.h>
#include<unistd.h>
#include<fstream.h>
#include"corbalogger.h"
#include"isdncti.h"
extern CorbaLog corbalog;
int isdncti_debuglevel=0;

extern char *descdatprefix; // aus main.cc
extern CORBA::ORB_ptr orb;  // aus main.cc

/* Funktion: hole ref aus dat ??? */
void IsdnCTIEventCallback::opencti(SimpleEventChannelAdmin::EventChannelFactory_ptr eventchannelfactory)
{
    char descdatpath[128];
    char descr[1024];
    char evref[1024];
    CORBA::Object_var myev_obj = CORBA::Object::_nil();

    snprintf(descdatpath,128,"%s%s",descdatprefix,"ctichannel");
    try
    {
	ifstream descdat(descdatpath,ios::in);

	if(!descdat)
	{
	    corbalog.log(Syslog::Err,"opencti: Datei %s nicht gefunden !",descdatpath);
	    descr[0]='\0';
	}
	else
	{
	    corbalog.setprio(Syslog::Debug);
	    descdat.getline(descr,1024);
	    if(!descdat.eof())
	    {
		descdat >> evref;
		if(strncmp(evref,"IOR:",4)==0
		   || strncmp(evref,"iioploc:",8)==0
		   || strncmp(evref,"iiopnam:",8)==0)
		{
		    if(isdncti_debuglevel>1)
		    {
			corbalog << "Referenz meines Eventchannels: " 
				 << evref << endl;
		    }
		    myev_obj = orb->string_to_object(evref);
		    if(myev_obj->_non_existent())
		    {
			if(isdncti_debuglevel >1)
			{
			    corbalog << "Gibt es nicht mehr !!!!!" << endl;
			}
			myev_obj = CORBA::Object::_nil();
		    }
		    else
		    {
			ctichannel = CosEventChannelAdmin::EventChannel::_narrow(myev_obj);
			if(CORBA::is_nil(ctichannel))
			{
			    if(isdncti_debuglevel >1)
			    {
				corbalog << "Kein Eventchannel " << endl;
			    }
			    myev_obj = CORBA::Object::_nil();
			}
		    }
		}
	    }
	}
    }
    catch(...)
    {
	myev_obj = CORBA::Object::_nil();
    }

    if(CORBA::is_nil(myev_obj))
    {
	corbalog << "Mu mir neuen Eventchannel erzeugen ... " << endl;
	assert(! CORBA::is_nil (eventchannelfactory));
	try
	{
	    ctichannel = eventchannelfactory->create_eventchannel();
	}
	catch(...)
	{
	    corbalog.log(Syslog::Crit,"Kann eventchannel nicht erzeugen !!!");
	}
	if(isdncti_debuglevel > 0)
	    corbalog << "Speichere in " << descdatpath << endl;
	CORBA::String_var evref = orb->object_to_string(ctichannel);
	
	ofstream speich(descdatpath);
 	speich << evref << endl;
	speich.close();
    }
    
    try
    {
	CosEventChannelAdmin::SupplierAdmin_var supadm = ctichannel->for_suppliers();
	pushconsumer = supadm->obtain_push_consumer();
	pushconsumer->connect_push_supplier(_this());
    }
    catch(CosEventChannelAdmin::AlreadyConnected_catch ex)
    {
	aktiv=0;
	corbalog.log(Syslog::Err,"Ctipushsupplier schon verbunden\n");
    }
    catch(...)
    {
	aktiv=0;
    }
}


void IsdnCTIEventCallback::callback(CORBA::Dispatcher *disp, CORBA::Dispatcher::Event ev)
{
    long n;
    char puffer[128];
    char local[32];
    char remote[32];  
    unsigned int si1,si2,plan,screen;

    switch(ev)
    {
    case CORBA::Dispatcher::Read:
	n = ::read(fd,puffer,128);
	if(n > 0)
	{
	    puffer[n]='\0';
	    if(isdncti_debuglevel>2)
	    {
		::write(1,puffer,n);
	    }
	    // C ist schoen effizient :-)
	    if(sscanf(puffer,"ICALL %s %s %x %x %x %x",remote,local,
		      &si1,&si2,&plan,&screen)==6 && si1==1)
	    {
		CORBA::Any any;
		DialupManager::call call;
		call.remote = (const char *)remote;
		call.local  = (const char *)local;
		
		any <<= call;
		try
		{
		    pushconsumer->push(any);
		}
		catch(...)
		{
		    corbalog.log(Syslog::Err,"cti->push fehlgeschlagen\n");
		}
	    }
	}
	break;      
    default: 
 	corbalog.setprio(Syslog::Err);
	corbalog << "IsdnEvent::callback Unerwarterter Eventtyp "
		 << ev << endl;
	corbalog.setprio(Syslog::Debug);
    }
}

void IsdnCTIEventCallback::disconnect_push_supplier()
{
    aktiv=0;
    corbalog.log(Syslog::Notice,"CTI-Channel disconnected");
}

