#include"prozess.h"
#include<pwd.h>
#include<fcntl.h>
#ifndef WITHOUT_CORBALOGGER
#include"corbalogger.h"
extern CorbaLog corbalog;
#define LOGOUT corbalog.log
#define LOGP1  Syslog::Crit
#else
#include<stdio.h>
#define LOGOUT fprintf
#define LOGP1  stderr
#endif

void Process::ssys(char *path,const char **arg)
{
    pid=fork();
    if(pid<0)
    {
	LOGOUT(LOGP1,"ssys: Cant fork(): %m");
	return;
    }
    if(pid)
    { /* Vater */
	istatus = running;
	return;
    }
    else
    {
	char *nullenv[1] = { NULL };
	/* Ein ganz stiller Sohn */
	int fn=open("/dev/null",O_RDWR);
	dup2(fn,0);
	dup2(fn,1);
	dup2(fn,2);
	execve(path,(char **)arg,nullenv);
	exit(1);
    }
}
int Process::openreadpipe(int uid,const char *cmd)
{
    int fd[2];
    if(pipe(fd)<0) return -1;

    pid=fork();
    if(pid<0) return -1;
    if(pid)
    { /* Vater */
	close(fd[1]);  // Schliee schreibe Seite
	istatus = running;
	return fd[0];
    }
    else
    { /* Sohn */
	const char *arg[10];
	char *env[20];
	char user[32],home[32],cwd[32];
	struct passwd *pwd=getpwuid(uid);
	int a=0;
	int e=0;
	if(pwd==NULL) 
	{
	    LOGOUT(LOGP1,"Nutzer mit uid %d gibt es nicht .... ",uid);
	}
	close(fd[0]);  // schliee leseseite
	close(1);      // schliesse stdout
	close(2);
	dup2(fd[1],1); // leite Standartausgabe auf pipe
	dup2(fd[1],2); // Leite Standarterror auf pipe
	if(setuid(uid)<0) 
	{
	  LOGOUT(LOGP1,"Setzen auf uid %d nicht moeglich: %m",uid);
	  exit(1);
	}
	arg[a++]="bash";
        //	arg[a++]="--login";
	arg[a++]="-c";
	arg[a++]=cmd;
	arg[a]=NULL;
	
	chdir(pwd->pw_dir);
	snprintf(user,32,"USER=%s",pwd->pw_name);
	env[e++]=user;
	snprintf(home,32,"HOME=%s",pwd->pw_dir);
	env[e++]=home;
	snprintf(cwd,32,"PWD=%s",pwd->pw_dir);
	env[e++]=cwd;
	env[e++]="PATH=/bin:/usr/bin";
	env[e]=NULL;

	execve("/bin/bash",(char **)arg,env);
	perror("execve");
	close(0);
	close(1);
        close(2);
	close(fd[1]);
	exit(1);
    }
}

int Process::wait()
{
    int wstatus;
    ::waitpid(pid,&wstatus,0);
    istatus = died;
    if(WIFEXITED(wstatus))
    {
	return exit_status=WEXITSTATUS(wstatus);
    }
    return -1;	
}

