/**************************************************************************
 * Header....: dirent.h                                                   *
 * Zweck.....: Iterator fr verzeichnisse, der dateien mit einer endung   *
 *             sammelt                                                    *
 **************************************************************************/
#ifndef DIRIT_H
#define DIRIT_H
#include<sys/types.h>
#include<dirent.h>
#include<string.h>

class Dirit
{
    const char *dir;
    const char *postfix;
    int plen;
    dirent *ent;
    DIR *verz;
 public:
    Dirit(const char *_dir,const char *_postfix)
	{
	    dir=_dir;
	    postfix=_postfix;
	    plen=strlen(postfix);
	    verz=opendir(dir);
	    next();
	}
    const char *operator()()
	{
	    return (ent!= NULL ? ent->d_name : (const char *)0);
	}
    const char *next()
	{
	    char *po;
	    while((ent=readdir(verz))!=0 && plen > 0
		  && ((po=strstr(ent->d_name,postfix))==NULL
		      || *(po+plen)!='\0')
		);
	}
    ~Dirit()
	{
	    closedir(verz);
	}
};

#endif
