
#include<iostream.h>
#include<fstream.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#define __USE_GNU
#include<unistd.h>
#include<pwd.h>
#include<sys/types.h>
#include<sys/wait.h>

class Process
{
    pid_t pid;
    int exit_status;
public:
    int openreadpipe(int uid,const char *cmd);   
    int wait();
};

int Process::openreadpipe(int uid,const char *cmd)
{
    int fd[2];
    if(pipe(fd)<0) return -1;

    pid=fork();
    if(pid<0) return -1;
    if(pid)
    { /* Vater */
	close(fd[1]);  // Schliee schreibe Seite
	return fd[0];
    }
    else
    { /* Sohn */
	const char *arg[10];
	char *env[20];
	char user[32],home[32],cwd[32];
	struct passwd *pwd=getpwuid(uid);
	int a=0;
	int e=0;
	if(pwd==NULL) 
	{
	    cerr << "Nutzer mit uid " << uid << " gibt es nicht .... " << endl;
	    exit(1);
	}
	close(fd[0]);  // schliee leseseite
	close(1);      // schliesse stdout
	dup2(fd[1],1); // leite Standartagabe auf pipe
	if(setuid(uid)<0) 
	{
	    cerr << "Setzen auf uid " << uid << " nicht moeglich !" << endl;
	    exit(1);
	}
	arg[a++]="bash";
	arg[a++]="--login";
	arg[a++]="-c";
	arg[a++]=cmd;
	arg[a]=NULL;
	
	chdir(pwd->pw_dir);
	snprintf(user,32,"USER=%s",pwd->pw_name);
	env[e++]=user;
	snprintf(home,32,"HOME=%s",pwd->pw_dir);
	env[e++]=home;
	snprintf(cwd,32,"PWD=%s",pwd->pw_dir);
	env[e++]=cwd;
	env[e++]="PATH=/bin:/usr/bin";
        env[e]=NULL;

	execve("/bin/bash",(char **)arg,env);
	perror("execve");
    }
}

int Process::wait()
{
    int status;
    ::waitpid(pid,&status,0);
    if(WIFEXITED(status))
    {
	return exit_status=WEXITSTATUS(status);
    }
    return -1;	
}

class queuemanager_impl
{
    int uid;
    char *fetchcmd;
    char *mailqcmd;
    char *queuelencmd;
public:
    queuemanager_impl();
    int lese(const char *datname);
    void testaus();
    int fetchandsend();
    int list();
};

queuemanager_impl::queuemanager_impl()
{
    uid=-1;
    fetchcmd="echo 'kein fetchcmd definiert'\n";
    mailqcmd="echo 'kein mailqcmd definiert'\n";
    queuelencmd="echo 'kein queuelencmd definiert'\n";
}

int queuemanager_impl::lese(const char *datei)
{
  char puffer[1024];

  fstream beschr(datei,ios::in);
  if(!beschr)
  {
      cerr << datei << " kann nicht gelesen werden !" << endl;
      return -1;
  }
 
  
  while(beschr.getline(puffer,1024,'\n'))
  {
      if(puffer[0]=='#') continue;
      if(strncmp(puffer,"uid=",4)==0)
      {
	 char *ep;
	 uid=strtol(puffer+4,&ep,10);
      }
      else if(strncmp(puffer,"fetchcmd=",9)==0)
      {
	  fetchcmd = strdup(puffer+9);
      }
      else if(strncmp(puffer,"mailqcmd=",9)==0)
      {
	  mailqcmd= strdup(puffer+9);
      }  
      else if(strncmp(puffer,"queuelencmd=",12)==0)
      {
	  queuelencmd=strdup(puffer+12);
      }
      else
      {
	  cout << "Unbekannt: " << puffer << endl;
      }
  }
  beschr.close();
}

void queuemanager_impl::testaus()
{
    cout << "uid=" << uid << endl;
    cout << "fetchcmd=" << fetchcmd << endl;
    cout << "mailqcmd=" << mailqcmd << endl;
    cout << "queuelencmd=" << queuelencmd << endl;
}

int queuemanager_impl::fetchandsend()
{
    int fd;
    char puffer[4096];
    char *p=puffer;
    int l;
    Process proc;
    fd=proc.openreadpipe(uid,fetchcmd);
    if(fd<0)
    {
	perror("openreadpipe");
	exit(1);
    }
    while((l=read(fd,p,1024))>0 && p<puffer+4096)
    {
	p+=l;
    }
    if(l<0) { perror("read");exit(1); }
    *p=0;
    cerr << "Laber: " << puffer << endl;
    close(fd);
    cerr << "exitstatus: " << proc.wait() << endl;
    return 0;
}

struct queueit
{
    int fd;
    char puffer[1024];
    Process proc;
    ifstream lq;

    int open(int uid,char *cmd);
    char *next_one()
    {
	if(lq.eof()) return NULL;
	lq.getline(puffer,1024);
	return puffer;
    }
    int ende()
    {
	close(fd);
	return proc.wait();
    }
};

int queueit::open(int uid,char *cmd)
{
    fd=proc.openreadpipe(uid,cmd);
    if(fd < 0) 
    {
	perror("Openreadpipe");return -1;
    }
    lq.attach(fd);
    if(!lq)
    {
	cerr << "Fehler beim lesen ... " << endl;
	return -1;
    }
}

int queuemanager_impl::list()
{
    queueit *qi=new queueit;
    char *z;
    if(qi->open(uid,mailqcmd)<0) return -1;
    while((z=qi->next_one())) cout << "L:" << z << endl;
    qi->ende();
    delete qi;
    return 0;
}

main(int argc,char **argv)
{
    queuemanager_impl qm;
    qm.lese(argv[1]);
    qm.testaus();
    qm.fetchandsend();
    // qm.list();
}

