
#ifndef __QUEUEMANAGER_IMPL_H__
#define __QUEUEMANAGER_IMPL_H__

#include"dialupmanager.h"
#include"prozess.h"
#include<fstream.h>

struct Devicelistentry
{
    DialupManager::DialDevice_var dd;
    DialupManager::DialDevice::DialMode alter_dm;
    Devicelistentry *nxt;

    Devicelistentry()
	{
	    dd=DialupManager::DialDevice::_nil();
	    nxt=NULL;
	}
    void init(const char *name) 
	throw(::CORBA::SystemException,DialupManager::Syserr);
};

// Implementation for interface Queuemanager
class Queuemanager_impl : virtual public POA_DialupManager::Queuemanager
{
 protected:
    CORBA::String_var iname;
    CORBA::String_var idesc;

    // Daten aus der Beschreibung 
    int uid;
    char *fetchcmd;
    char *mailqcmd;
    char *queuelencmd;

    // Liste der verbundenen Dialdevices
    Devicelistentry *ddlwurzel;
 public:
    Queuemanager_impl(const char *name);

    char* name()
      throw(
        ::CORBA::SystemException)
    ;

    char* desc()
      throw(
        ::CORBA::SystemException)
    ;

    void fetchandsend()
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;

    CORBA::Long howmanyentries()
      throw(
        ::CORBA::SystemException,
	DialupManager::Syserr)
    ;

    void listentries( CORBA::ULong howmany, DialupManager::EntrydescList*& list, DialupManager::QueueentryIterator_ptr& queit )
      throw(
        ::CORBA::SystemException,
        DialupManager::Syserr)
    ;
    
    /*---------- sonstige ---------------*/
    int lese(const char *datname);
    void opendevices();
    void closedevices();
    void testaus(ostream &ostr);
};


// Implementation for interface QueueentryIterator
class QueueentryIterator_impl : virtual public POA_DialupManager::QueueentryIterator
{
    int fd;
    char puffer[1024];
    Process proc;
    ifstream lq;

 public:
    int open(int uid,char *cmd);
    char *next_one()
    {
	if(lq.eof()) return NULL;
	lq.getline(puffer,1024);
	return puffer;
    }
    int ende()
    {
	close(fd);
	return proc.wait();
    }
    CORBA::Boolean eof() 
    {
	return lq.eof();
    }
  public:

    CORBA::Boolean next_one( char*& entry )
      throw(
        ::CORBA::SystemException)
    ;

    CORBA::Boolean next_n( CORBA::ULong how_many, DialupManager::EntrydescList*& bl )
      throw(
        ::CORBA::SystemException)
    ;

    void destroy()
      throw(
        ::CORBA::SystemException)
    ;
};


#endif

