#include"queuemanager_impl.h"
#include"queuepoa.h"
#include"corbalogger.h"
int queuepoa_debuglevel=0;
extern CorbaLog corbalog;

typedef map<PortableServer::Servant,Queuemanager_impl *,less<PortableServer::Servant> > QueuemanagerServantMap;

static QueuemanagerServantMap qmsm;

extern char *descdatprefix;
PortableServer::Servant QueuePOAManager::incarnate (const PortableServer::ObjectId &oid,
                                     PortableServer::POA_ptr poa)
{
    CORBA::String_var name=PortableServer::ObjectId_to_string(oid);
    Queuemanager_impl *ret;
    char descdatpath[128];
    
    if(queuepoa_debuglevel > 0)
    {
	corbalog.setprio(Syslog::Debug);
	corbalog << "incarnate Queuemanager " << name << endl;
    }
    snprintf(descdatpath,128,"%s%s.queue",descdatprefix,(char *)name);
    
    ret = new Queuemanager_impl(name);
    ret->lese(descdatpath);
    if(queuepoa_debuglevel > 0)  ret->testaus(corbalog);
    qmsm[ret]=ret;
    return ret;
}

void QueuePOAManager::etherealize (const PortableServer::ObjectId &oid,
                    PortableServer::POA_ptr poa,
                    PortableServer::Servant serv,
                    CORBA::Boolean cleanup_in_progress, 
		    CORBA::Boolean remaining_activations)
{
    
    CORBA::String_var nid=PortableServer::ObjectId_to_string(oid);

    if(queuepoa_debuglevel > 0)
    {
	corbalog.setprio(Syslog::Debug);
	corbalog << "etherealize " << nid << endl;
    }

    if (!remaining_activations) 
    {
	QueuemanagerServantMap::iterator it = qmsm.find(serv);
	assert(it!=qmsm.end());

	if(queuepoa_debuglevel > 0)
	{
	    corbalog << " Verabschiede mich von Queuemanager "
		     << (*it).second->name() << endl;
	}
	qmsm.erase(it);
	delete serv;
    }
    else
    {
	if(queuepoa_debuglevel > 0)
	{
	    corbalog << "Noch Aufrufe ... " << endl;
	}
    }
}
