#include"syslog.h"
#include<mico/dynany.h>
#include"dynanyoutput.h"

DynAnyOutput out(cout);

main(int argc,char **argv)
{
    CORBA::ORB_var orb = CORBA::ORB_init(argc,argv,"mico-local-orb");
    CORBA::Object_var dynfobj=orb->resolve_initial_references("DynAnyFactory");
    DynamicAny::DynAnyFactory_var dynaf=DynamicAny::DynAnyFactory::_narrow(dynfobj);
    Syslog::LogRecordUnix lr;
    CORBA::Any any;
    lr.facility = CORBA::string_dup("test");
    lr.prog     = CORBA::string_dup("anytest");
    lr.pid      = 1227;
    lr.location = CORBA::string_dup("rws");
    lr.time     = 937608819;
    lr.priority = Syslog::Crit;
    lr.message  = CORBA::string_dup("Guten Tag");

    any <<= lr;

    DynamicAny::DynAny_var dyna = dynaf->create_dyn_any(any);

    CORBA::TypeCode_ptr tc = dyna->type();
    if(tc->kind() == CORBA::tk_struct)
    {
	cerr << "Typ ist ein struct " << endl;
	DynamicAny::DynStruct_var dynstr = DynamicAny::DynStruct::_narrow(dyna);
	do
	{
	    CORBA::String_var mn = dynstr->current_member_name();
	    DynamicAny::DynAny_var comp = dynstr->current_component();
	    cout << mn << " ";
            out.show_DynAny(comp); 
            cout << endl;
	} while(dynstr->next());
    }

#if 0
    cout << "------------------ show(Any) ------------------------" << endl;
    out.show_Any(any);
    cout << "------------------ display(Any) ---------------------" << endl;
    out.display_Any(any);

    cout << "\n---------------- show(DynAny) ---------------------" << endl;
    out.show_DynAny(dyna);
#endif

    cout << "\n---------------- display(DynAny) ---------------------" << endl;
    out.display_DynAny(dyna);

}
