
#ifndef __CONTROL_IMPL_H__
#define __CONTROL_IMPL_H__
#include<string>
#include<map.h>
#include "control.h"

#ifdef LIBSTD
typedef map<string,int *,less<string> > Debugvarmap;
#else
struct Debugvar
{
  const char *name;
  int *pval;
};

typedef Debugvar *Debugvarmap;
#endif

// Implementation for interface Control
class Control_impl : virtual public POA_AppControl::Control
{
 protected:
     Debugvarmap dvm;
     CORBA::String_var iname;
#ifndef LIBSTD
     int dvmsize;
     Debugvar *find(const char *name);
#endif
 public:
#ifdef LIBSTD
    Control_impl(const char *pname);
#else
    Control_impl(const char *pname,Debugvar *_dvm,int _dvmsize);
#endif
    char *name()
	throw(::CORBA::SystemException)
    ;
    CORBA::Long getpid()
	throw(::CORBA::SystemException)
    ;
    AppControl::Debugseq* getdebugvars()
      throw(
        ::CORBA::SystemException)
    ;

    void setdebugvars( const AppControl::Debugseq& ds )
      throw(
        ::CORBA::SystemException)
    ;

    void exportnames( CosNaming::NamingContext_ptr nc )
      throw(
        ::CORBA::SystemException)
    ;
 public:
#ifdef LIBSTD
   virtual void init_debugtab(); // wird automatisch generiert
#endif
   void print_debugtab(ostream &str);
};

#endif
