#include<iostream.h>
#include<fstream.h>
#include"control_impl.h"

// Debugvariablen 
int main_debuglevel=0;
int dialdevice_debuglevel=0;
int isdnevent_debuglevel=0;
int isdnsystem_debuglevel=0;
int queuemanager_debuglevel=0;
int queuepoa_debuglevel=0;

#ifdef LIBSTD
class myControl_impl: public Control_impl
{
public:
    myControl_impl::myControl_impl(const char *pname):Control_impl(pname) {}
    void init_debugtab();
    void exportnames( CosNaming::NamingContext_ptr nc) 
      throw(::CORBA::SystemException);

};


void myControl_impl::init_debugtab()
{
   dvm["main"] = &main_debuglevel;
   dvm["dialdevice"] = &dialdevice_debuglevel;
   dvm["isdnevent"] = &isdnevent_debuglevel;
   dvm["isdnsystem"] = &isdnsystem_debuglevel;
   dvm["queuemanager"] = &queuemanager_debuglevel;
   dvm["queuepoa"] = &queuepoa_debuglevel;
}
#else
class myControl_impl: public Control_impl
{
public:
    myControl_impl::myControl_impl(const char *pname,Debugvarmap _dvm,int dvmsz):Control_impl(pname,_dvm,dvmsz) {}
    void exportnames(CosNaming::NamingContext_ptr nc) 
      throw(::CORBA::SystemException);

};

Debugvar dvmt[]=
{
   {"main",&main_debuglevel},
   {"dialdevice",&dialdevice_debuglevel},
   {"isdnevent",&isdnevent_debuglevel},
   {"isdnsystem",&isdnsystem_debuglevel},
   {"queuemanager",&queuemanager_debuglevel},
   {"queuepoa",&queuepoa_debuglevel},
   {NULL,NULL}
};

#endif

void
myControl_impl::exportnames(CosNaming::NamingContext_ptr nc )
  throw(::CORBA::SystemException)

{
    cerr << "exportnames ..." << endl;
}

int main(int argc,char **argv)
{
  // Orb und Boa initialisieren
  CORBA::ORB_var orb = CORBA::ORB_init(argc,argv,"mico-local-orb");
  CORBA::Object_var poaobj = orb->resolve_initial_references("RootPOA");
  PortableServer::POA_var poa = PortableServer::POA::_narrow(poaobj);
  PortableServer::POAManager_var mgr = poa->the_POAManager();

#ifdef LIBSTD
  myControl_impl *servant = new myControl_impl("Controltest");
  servant->init_debugtab();
#else
  myControl_impl *servant = new myControl_impl("Controltest",dvmt,sizeof(dvmt)/sizeof(struct Debugvar));
#endif

  PortableServer::ObjectId_var oid = poa->activate_object(servant);
 
  mgr->activate();
  ofstream ctlfile("/tmp/controltest.ctlref");
  if(!ctlfile)
  {
      cerr << "Kann /tmp/controltest.ctlref nicht schreiben " << endl;
      exit(1);
  }
  ctlfile << orb->object_to_string(servant->_this()) << endl;
  servant->print_debugtab(cout);
  orb->run();
}








