/*****************************************************************************
 * Header......: corbalib.h                                                  *
 * Zweck.......: hufig gebrauchte Funktionen zu CORBA/MICO                  *
 * Author......: Rudolf Weber Informatik- und Netzwerkverein Ravensburg e.V  *
 * Copyright...: GNU Library  1999                                           *
 *****************************************************************************/
#ifndef CORBALIB_H
#define CORBALIB_H
#include<iostream.h>
#include<mico/CosNaming.h>
#include<mico/ir.h>
#include<stdio.h>

/*-------------- Nameservice --------------------------*/
// ps: Pfadseperator, ks kind-Separator
CosNaming::Name &StringToName(CosNaming::Name &name,char *namestr,char ps='/',char ks='.');
void print(ostream &str,const CosNaming::Name &name,int withkind=0,char ps='/',char ks='.');
ostream& operator <<(ostream &str,const CosNaming::Name &name);

/*---------- Repository -------------------------------*/
class ClException
{
protected:
    char msg[128];    
public:
    virtual void _print (ostream &) const;
};

class ClNotFound : public ClException
{
public:
    ClNotFound(const char *repoid)
    {
	snprintf(msg,128,"Repoid %s nicht vorhanden",repoid);
    }
};

class ClNoTypedef : public ClException
{
public:
    ClNoTypedef(const char *repoid)
    {
	snprintf(msg,128,"Repoid %s keine CORBA::TypedefDef",repoid);
    }
};

class ClTypeerr: public ClException
{
public:
   ClTypeerr(const char *repoid,const char *sollte_sein)
   {
       snprintf(msg,128,"Repoid %s kein %s",repoid,sollte_sein);
   }
};

CORBA::TypeCode_ptr tc_from_repo_id(CORBA::Repository_ptr repo,const char *repo_id) throw(ClNotFound,ClNoTypedef);

/*---------------- Dynany --------------------------*/
int find_comp_by_name(DynamicAny::DynStruct_ptr ds,const char *name);

#endif


