#include"corbalogger.h"
#include<string.h>
#include<sys/time.h>
#include<unistd.h>
#include<iostream.h>
#include<sys/errno.h>

#ifdef BOAIMPL
#define PUSHSUPPLIERSKEL CosEventComm::PushSupplier_skel
#else
#define PUSHSUPPLIERSKEL POA_CosEventComm::PushSupplier
#endif

class PushSupplier_impl : virtual public PUSHSUPPLIERSKEL
{
    CorbaLog *cl;
public:
    PushSupplier_impl(CorbaLog *_cl) { cl=_cl; }
    void disconnect_push_supplier();
};

void PushSupplier_impl::disconnect_push_supplier()
{
    cerr << "Corbalog-PushSupplier wird abgehngt " << endl;
}

void CorbaLog::init(CORBA::ORB_ptr orb_,CosEventChannelAdmin::EventChannel_ptr ev,Syslog::Facility fac,Syslog::Prog prog_)
{
  char hostname[32];
  orb=orb_;
  /*--------------- Einhngen als Pushsupplier ---------*/
  CosEventChannelAdmin::SupplierAdmin_var sa = ev->for_suppliers();
  PushSupplier_impl *psi = new PushSupplier_impl(this);
  ps = psi->_this();
  pc = sa->obtain_push_consumer();
  pc->connect_push_supplier(ps);
 
  /*----- Initialisieren der schon bekannten Daten -----*/
  facility = strdup(fac);
  prog     = strdup(prog_);
  pid      = getpid();
  gethostname(hostname,32);
  location = strdup(hostname);
  /* 
   * Eventuell mu hier die Location besser ermittelt werden:
   * - uname()
   * - Ip-Adresse ermitteln und rckwrtsauflsen
   * - ????
   */
  prio = Syslog::Debug;
}

void CorbaLog::setmessage(char *form,va_list args)
{
    char *format = form;
    char format_sp[256];
    char *pm=strstr(form,"%m");
    register int l = pm-form;
    if(pm!=NULL && l<220)
    {
	char *pq,*pz;
	strncpy(format_sp,form,l);
	pq = strerror(errno);
	pz=format_sp+l;
	while(pz-format_sp < 255 && *pq != '\0') *pz++=*pq++;
	pq=pm+2;
	while(pz-format_sp < 255 && *pq != '\0') *pz++=*pq++;
	*pz='\0';
	format = format_sp;
    }
    vsnprintf(message,512,format,args);
}

void CorbaLog::log(Syslog::Priority prio,char *mess,...)
{
    va_list args;
    va_start(args,mess);
    vlog(prio,mess,args);
    va_end(args);
}

void CorbaLog::vlog(Syslog::Priority prio,char *mess,va_list args)
{
    Syslog::LogRecordUnix lr;
    struct timeval tv;
    gettimeofday(&tv,NULL);
    CORBA::Any msg;
    lr.facility = (const char *)facility;
    lr.prog     = (const char *)prog;
    lr.pid      = pid;
    lr.location = (const char *)location;
    lr.time     = tv.tv_sec;
    lr.priority = prio;
    setmessage(mess,args);
    lr.message  = (const char *)message;

    msg <<= lr;
    pc->push(msg);
}

void CorbaLog::clog(CORBA::Object_ptr obj_,Syslog::Priority prio,char *mess,...)
{
    va_list args;
    va_start(args,mess);
    vclog(obj_,prio,mess,args);
    va_end(args);
}

void CorbaLog::vclog(CORBA::Object_ptr obj,Syslog::Priority prio,char *mess,va_list args)
{
    Syslog::LogRecordCorba lr;
    struct timeval tv;
    gettimeofday(&tv,NULL);
    CORBA::Any msg;
    lr.facility = (const char *)facility;
    lr.prog     = (const char *)prog;
    lr.pid      = pid;
    lr.location = (const char *)location;
    lr.time     = tv.tv_sec;
    lr.priority = prio;
    lr.obj      = CORBA::Object::_duplicate(obj);
    setmessage(mess,args);
    lr.message  = (const char *)message;
    
    msg <<= lr;
    pc->push(msg);
}


void CorbaLog::callback(void *data,char *str,int l)
{
    CorbaLog *ich=(CorbaLog *)data;
    if(ich->message!=str)
    {
	memcpy(ich->message,str,l);
    }
    ich->send();
}

void CorbaLog::send()
{

    struct timeval tv;
    gettimeofday(&tv,NULL);
    CORBA::Any msg;

    if(CORBA::is_nil(obj))
    {
	Syslog::LogRecordUnix lr;
	lr.facility = (const char *)facility;
	lr.prog     = (const char *)prog;
	lr.pid      = pid;
	lr.location = (const char *)location;
	lr.time     = tv.tv_sec;
	lr.priority = prio;
	lr.message  = (const char *)message;
    
	msg <<= lr;
    }
    else
    {
	Syslog::LogRecordCorba lr;
	lr.facility = (const char *)facility;
	lr.prog     = (const char *)prog;
	lr.pid      = pid;
	lr.location = (const char *)location;
	lr.time     = tv.tv_sec;
	lr.priority = prio;
	lr.obj      = CORBA::Object::_duplicate(obj);
	lr.message  = (const char *)message;
    
	msg <<= lr;
    }
    pc->push(msg);
}



