/*************************************************************************
 * Corba-Ersatz von syslog(3)                                            *
 *************************************************************************/
#ifndef CORBALOGGER_H
#define CORBALOGGER_H
#include"syslog.h"
#ifdef BOAIMPL
#include<mico/CosEventChannelAdmin.h>
#else
#include"CosEventChannelAdmin.h"
#endif
#include<stdarg.h>
#include"corbalib.h"
#include<mico/dynany.h>
#include"logbuf.h"

/*------------------- Corbalog --------------------------*/
class CorbaLog : public ostream
{
private:
    logbuf str;

    // ORB und Services
    CORBA::ORB_var orb;

    // Eventchannels
    CosEventChannelAdmin::ProxyPushConsumer_var pc;
    CosEventComm::PushSupplier_var ps;

    //Interne Daten
    Syslog::Facility_var facility;
    Syslog::Prog_var prog;
    Syslog::Location_var location;
    Syslog::Pid pid;
    Syslog::Priority prio;
    CORBA::Object_var obj;
    char message[512];

protected:
    void clearmsg() { str.reinit(); }
    void send();
public:
    CorbaLog():ostream(&str),str(message,512) 
	{
	    str.initcb(callback,this);
	}
    static void callback(void *data,char *str,int l);

    void init(CORBA::ORB_ptr orb,CosEventChannelAdmin::EventChannel_ptr ev,Syslog::Facility fac,Syslog::Prog prog);    
    

    void setprio(Syslog::Priority prio_) { prio = prio_; }
    void setobjref(CORBA::Object_ptr obj_)
	{ obj=CORBA::Object::_duplicate(obj_);
	}
    void setmessage(char *message,va_list args);

    void log(Syslog::Priority prio,char *message,...);
    void vlog(Syslog::Priority prio,char *message,va_list args);
    void clog(CORBA::Object_ptr obj,Syslog::Priority prio,char *message,...);
    void vclog(CORBA::Object_ptr obj,Syslog::Priority prio,char *message,va_list args);
};

#endif

