#include<CORBA.h>
#include<iostream.h>
#include<mico/dynany.h>
#include"dynanyoutput.h"
#include"syslog.h"

DynAnyOutput out(cout);

int main(int argc,char **argv)
{
  CORBA::ORB_var orb = CORBA::ORB_init(argc,argv,"mico-local-orb");
  CORBA::Object_var dynafobj = orb->resolve_initial_references ("DynAnyFactory");
  assert(!CORBA::is_nil(dynafobj));
  DynamicAny::DynAnyFactory_var dynaf = DynamicAny::DynAnyFactory::_narrow(dynafobj);
  assert(!CORBA::is_nil(dynaf));
  out.set_fac(dynaf);
  CORBA::Object_var repoobj = orb->resolve_initial_references("InterfaceRepository");
  assert(!CORBA::is_nil(repoobj));
  CORBA::Repository_var repo = CORBA::Repository::_narrow(repoobj);
  assert(!CORBA::is_nil(repo));
  CORBA::Contained_var con = repo->lookup_id("IDL:Syslog/LogRecordUnix:1.0");
  if(CORBA::is_nil(con))
  {
      cerr << "IDL:Syslog/LogRecordCorba:1.0" << " nicht vorhanden !" << endl;
      exit(1);
  }
  if(orb->is_a(con,"IDL:omg.org/CORBA/StructDef:1.0"))
  {
      cerr << "IDL:Syslog/LogRecordCorba:1.0 ist vom Typ IDL:omg.org/CORBA/StructDef:1.0 " << endl;
  }
  CORBA::StructDef_var strdef = CORBA::StructDef::_narrow(con);
  if(CORBA::is_nil(strdef))
  {
      cerr << "kein  IDL:omg.org/CORBA/StructDef:1.0 " << endl;
      exit(1);
  }
  CORBA::TypeCode_var tc = strdef->type();
  out.display_IDL_TypeCode(tc);

  DynamicAny::DynAny_var tmp = dynaf->create_dyn_any_from_type_code(tc);
  DynamicAny::DynStruct_var lr = DynamicAny::DynStruct::_narrow(tmp);
#ifndef LEER
  /* fuellen */
  lr->insert_string(CORBA::string_dup("facility"));
  lr->next();
  lr->insert_string(CORBA::string_dup("prog"));
  lr->next();
  lr->insert_string(CORBA::string_dup("location"));
  lr->next();
  lr->insert_long(117);
  lr->next();
  lr->insert_long(927608819);
  lr->next();
  DynamicAny::DynAny_var current_component = lr->current_component();
  DynamicAny::DynEnum_var dyn_enum = DynamicAny::DynEnum::_narrow(current_component);
  dyn_enum->set_as_string("Debug");
  out.show_DynAny(dyn_enum);
  lr->next();
  lr->insert_string((const char *)"Guten Tag");
#endif

  cout << "\n---------------- display(DynAny) ---------------------" << endl;
  out.display_DynAny(lr);

  CORBA::Any_var lrany;
  lrany = lr->to_any();
  lr->destroy();
    
  cout << "------------------ show(Any) ------------------------" << endl;
  out.show_Any(lrany);
}








