/*****************************************************************************
 * Klasse logbuf.h                                                           *
 * Zweck...: logbuf ist ein Streambuf, der alles bis zum Zeilenumbruch       *
 *           sammelt und dann das gesammelte via Callbackfunktion            *
 *           nach auen reicht                                               *
 *           In der Callbackfunktion kann z.B syslog(3) oder unser           *
 *           Corbalogger aufgerufen werden                                   *
 * Author..: Rudolf Weber                                                    *
 * Copyright: Informatik- und Netzwerkverein Ravensburg e.V  1999            *
 *            wie LGPL                                                       *
 *****************************************************************************/
#ifndef LOGBUF_H
#define LOGBUF_H
#include<iostream.h>


typedef void (*logbufcallback)(void *data,char *zeile,int l);

class logbuf : public streambuf
{
private:
    char *puffer;
    int plen;
    char *p;
    int rest;
    void *cbdata;
    logbufcallback cb;
protected:
    int uebernehmen(char *str,int len);
public:
    logbuf(char *buf,int len);
    void initcb(logbufcallback cbf,void *data)
	{
	    cb=cbf;
	    cbdata=data;
	}
    int sync();
    int overflow(int ch);
    // Defining xsputn is an optional optimization.
    // (streamsize was recently added to ANSI C++, not portable yet.)
    streamsize xsputn (char* text, streamsize n);

 public: // speziell
    void reinit();
};
#endif
