#include<unistd.h>
#include"corbalib.h"
#include"corbalogger.h"
#include<string.h>

CorbaLog corbalog;

/*------------ Ereignisbehandler ------------------------------*/
class EingabezuEreignisCallback: public CORBA::DispatcherCallback
{
    char puffer[4097];
    CORBA::Long fd;
public:
    EingabezuEreignisCallback(CORBA::Long pfd)
	{
	    fd=pfd;
	}
    void callback(CORBA::Dispatcher *, CORBA::Dispatcher::Event);
};

void EingabezuEreignisCallback::callback(CORBA::Dispatcher *disp,CORBA::Dispatcher::Event ev)
{
    int l;
    char *p;
    int loglevel;
    switch(ev)
    {
    case CORBA::Dispatcher::Read:
	l=::read(fd,puffer,4096);
	if(l<=0) 
	{
	    perror("EingabezuEreignisCallback::read");return;
	}
	if(puffer[l-1]=='\n')
	    puffer[l-1]='\0';
	else
	    puffer[l]='\0';
	
	cerr << "lese " << puffer << endl;
	loglevel = strtol(puffer,&p,10);
	if(loglevel < 0 || loglevel > 6)
	{
	    loglevel = 6;
	}
	corbalog.log((Syslog::Priority)loglevel,p);
	break;
    default: 
	cerr << "Unerwarterter Eventtyp " << ev << endl;
    }
}



main(int argc,char **argv)
{
    char *prog = rindex(argv[0],'/');
    prog = (prog ? prog+1 : argv[0]);

    CORBA::ORB_var orb = CORBA::ORB_init(argc,argv,"mico-local-orb");
#ifdef BOAIMPL
    CORBA::BOA_var boa = orb->BOA_init(argc,argv,"mico-local-boa");
#else
    CORBA::Object_var poaobj = orb->resolve_initial_references("RootPOA");
    PortableServer::POA_var poa = PortableServer::POA::_narrow(poaobj);
    PortableServer::POAManager_var mgr = poa->the_POAManager();
    mgr->activate();
#endif

  /*----- Initialisiere Corbalogger -----------------------*/
  CosNaming::Name syslogevname;
  CORBA::Object_var syslogevobj;
  CORBA::Object_var nsobj = orb->resolve_initial_references("NameService");
  if(CORBA::is_nil(nsobj))
  {
    cerr << "Hallo: Initial Service NameService not resolved " << endl;
    exit(1);
  }
  CosNaming::NamingContext_var nc =CosNaming::NamingContext::_narrow (nsobj);


  try
  {
      syslogevobj =nc->resolve(StringToName(syslogevname,"syslog"));
  }
  catch(...)
  {
      cerr << "Kann syslog nicht finden !! " << endl;
      exit(1);
  }
      
  CosEventChannelAdmin::EventChannel_var syslogev = CosEventChannelAdmin::EventChannel::_narrow(syslogevobj);
  assert(! CORBA::is_nil (syslogev));

  corbalog.init(orb,syslogev,"Test",prog);

#ifdef BOAIMPL
  boa->impl_is_ready(CORBA::ImplementationDef::_nil());
#endif

  /*-------------- Hier wird nun gearbeitet und geloggt ---- */
  corbalog.log(Syslog::Info,"Hallo Welt");
  corbalog.log(Syslog::Debug,"Name=%s ","logtest");
  for(int i=0;i<9;i++)
  {
    corbalog.log(Syslog::Debug,"Zahl=%d",i);  
  }
  corbalog << "Ich bin der tollste ";
  corbalog << "logger\n den Rudolf gebaut hat " << endl;
  cerr << "Wir haengen unsere Ereignisbehandlungsroutine mit ein ... " << endl;
  EingabezuEreignisCallback *eecb = new EingabezuEreignisCallback(0);
  orb->dispatcher()->rd_event(eecb,0);
  orb->run();
}
